// ライブラリの設定
#include <SPI.h>
#include "myLovyanGFX.hpp"

static LGFX lcd;
#define OLED_RESET -1

int WIDTH=20;
int HEIGHT=14;
int PX0=0;
int PY0=16;
int CW=16;
int CH=16;
int cur=0;
int len;
int scroll=0;
String vram[16];

void setup() {
  lcd.init();
  lcd.setRotation(2);  
  lcd.fillScreen(TFT_BLACK);
  lcd.setSwapBytes(true);
  Serial.begin(115200);
  lcd.setTextColor(TFT_YELLOW);
  //lgfxJapanGothic_16 :(8/12/16/20/24/28/32/36/40px monospaced font);
  lcd.setFont(&fonts::lgfxJapanGothic_16);
  lcd.setCursor(PX0, 0); lcd.print("MZ-80C MONITOR <UART COMMUNICATION>");
}
int dispLine(int k,String str){
  lcd.fillRect(PX0,PY0+k*CH,320,CH,TFT_BLACK);
  lcd.setTextColor(TFT_GREEN,TFT_BLACK);
  lcd.setCursor(PX0,PY0+k*CH);lcd.print(str);
  vram[k]=str;
  return k+1;
}
void loop() {
  char buf[1024];
  len=0;
  memset(buf, 0, 1024);
  while(Serial.available()){
    buf[len]=char(Serial.read());
    len++;
  }
  if (len>0){
    delay(100);
    String strbuf=buf;
    Serial.println(strbuf); // UART通信で受信した値をシリアルモニタに表示
    if (cur<HEIGHT-1){
      cur=dispLine(cur,strbuf);
    } else {
      if (scroll==0){
        cur=dispLine(cur,strbuf);
        scroll=1;
      } else {
        vram[HEIGHT]=strbuf;
        for (int i=0; i<HEIGHT; i++){
          vram[i]=vram[i+1];
          dispLine(i,vram[i]);
        }
        cur=HEIGHT-1;
      }
    }
  }
}
