// ライブラリの設定
#include <WiFi.h> // WiFi接続
#include <Wire.h>
#include <WiFiUdp.h>
#include <SPI.h>
#include "myLovyanGFX.hpp"

static LGFX lcd;
const char *ssid     = "**********"; //WiFi接続ID ;
const char *password = "**********"; //WiFi接続パスワード ;             
#define SSID "elecom2g-7664f1"          // 無線LANアクセスポイントのSSID
#define PASS "BvhFrxXZlrH1"              // パスワード
#define OLED_RESET -1

const int myLocalport = 2000;
WiFiUDP udp;
int WIDTH=20;
int HEIGHT=14;
int PX0=0;
int PY0=16;
int CW=16;
int CH=16;
int cur=0;
int scroll=0;
String vram[16];
void setup() {
  // WiFi接続開始
  WiFi.begin(ssid, password);
  while(WiFi.status() != WL_CONNECTED){   // 接続に成功するまで待つ
    Serial.print ( "." );
    delay(500);                           // 待ち時間処理
  }
  lcd.init();
  lcd.setRotation(2);  
  lcd.fillScreen(TFT_BLACK);
  lcd.setSwapBytes(true);
  Serial.begin(115200);
  lcd.setTextColor(TFT_YELLOW);
  //lgfxJapanGothic_16 :(8/12/16/20/24/28/32/36/40px monospaced font);
  lcd.setFont(&fonts::lgfxJapanGothic_16);
  String myLip=WiFi.localIP().toString();   // IPアドレスを取得
  Serial.println("myIP:"+myLip+":"+String(myLocalport));
  udp.begin(myLocalport);  // UDP通信の開始(引数はポート番号)
  lcd.setCursor(PX0, 0); lcd.print("MZ-80C MONITOR <"+myLip+":"+String(myLocalport)+">");
}
int dispLine(int k,String str){
  lcd.fillRect(PX0,PY0+k*CH,320,CH,TFT_BLACK);
  lcd.setTextColor(TFT_GREEN,TFT_BLACK);
  lcd.setCursor(PX0,PY0+k*CH);lcd.print(str);
  vram[k]=str;
  return k+1;
}
void loop() {
  char buf[1024];
  memset(buf, 0, 1024);                     // 文字列変数bufの初期化(1024バイト)
  int len = udp.parsePacket();                // 受信パケット長を変数lenに代入
  if (len>0){
    udp.read(buf, 1024);                     // 受信文字列を変数bufに格納する
    delay(60);
    String strbuf=buf;
    Serial.println(strbuf); // UDP通信で受信した値をシリアルモニタに表示
    if (cur<HEIGHT-1){
      cur=dispLine(cur,strbuf);
    } else {
      if (scroll==0){
        cur=dispLine(cur,strbuf);
        scroll=1;
      } else {
        vram[HEIGHT]=strbuf;
        for (int i=0; i<HEIGHT; i++){
          vram[i]=vram[i+1];
          dispLine(i,vram[i]);
        }
        cur=HEIGHT-1;
      }
    }
  }
}
